function varargout=plot(self,u,varargin)
  H=[];
  eval(sprintf('H=PlotSubTh%dsimp%dD(self,u,varargin);',self.d,self.dim));
  if nargout==1,varargout{1}=H;end
end

function h=PlotSubTh3simp3D(self,u,PlotOptions)
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  view(3)
  % h=scatter3(self.q(1,:),self.q(2,:),self.q(3,:),self.get_h(),U); % Nuage de points. Tres lent sous Octave
  idx=nchoosek(1:4,2);
  % To optimize
  for i=1:size(idx,1)
    if fc_tools.comp.isOctave()
      [Q,ME,V]=PatchOctave(self,U,idx(i,:));
      h(i)=patch('Vertices',Q,'Faces',ME,'facevertexcdata',V,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    else
      h(i)=patch('Vertices',self.q','Faces',self.me(idx(i,:),:)','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    end
  end
end

function h=PlotSubTh2simp3D(self,u,PlotOptions)
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  view(3)
  h=patch('Vertices',self.q','Faces',self.me','facevertexcdata',U,'FaceColor','interp',PlotOptions{:});%'FaceColor','interp');%,'FaceColor','none','LineWidth',2)
end

function h=PlotSubTh1simp3D(self,u,PlotOptions)
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  view(3)
  if fc_tools.comp.isOctave()
    [Q,ME,V]=PatchOctave(self,U,1:2);
    h=patch('Vertices',Q,'Faces',ME,'facevertexcdata',V,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
  else
    h=patch('Vertices',self.q','Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
  end
end

function h=PlotSubTh2simp2D(self,u,PlotOptions)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('plan',false);
  p.parse(PlotOptions{:});
  R=p.Results;
  PlotOptions=fc_tools.utils.deleteCellOptions(PlotOptions,p.Parameters);
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  if R.plan
      h=patch('Vertices',self.q','Faces',self.me','facevertexcdata',U,'FaceColor','interp',PlotOptions{:});
  else
    h=trisurf(self.me',self.q(1,:),self.q(2,:),U,PlotOptions{:});
  end
end

function h=PlotSubTh1simp2D(self,u,PlotOptions)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('plan',false);
  p.parse(PlotOptions{:});
  R=p.Results;
  PlotOptions=fc_tools.utils.deleteCellOptions(PlotOptions,p.Parameters);
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  if fc_tools.comp.isOctave()
    [Q,ME,V]=PatchOctave(self,U,1:2);
    if R.plan
      h=patch('Vertices',Q,'Faces',ME,'facevertexcdata',V,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    else
      h=patch('Vertices',[Q,V],'Faces',ME,'facevertexcdata',V,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    end
  else  
    if R.plan 
      h=patch('Vertices',self.q','Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    else
      h=patch('Vertices',[self.q',U],'Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
    end
  end
end

function h=PlotSubTh1simp1D(self,u,PlotOptions)
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  [qs,Ind]=sort(self.q);
  h=plot(qs,U(Ind),PlotOptions{:});
end

% 
function [Q,ME,V]=PatchOctave(self,U,id)
  Qeps=self.q;
  Qeps(1,:)=Qeps(1,:)+10*eps/self.h;
  Q=[self.q,Qeps]';
  ME=self.me(id,:);
  ME=[ME;ME(1,:)+self.nq]';
  V=[U;U];
end